From dc7707ff3033bcb2ec321d164b51716a9513a269 Mon Sep 17 00:00:00 2001
From: Eric Barbour <emb4gu@virginia.edu>
Date: Jul 26 2016 15:13:59 +0000
Subject: [PATCH 578/1001] Naive implementation of User Members widget


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 323aa70..6423e3e 100755
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -16,6 +16,7 @@ from hubs.widgets import pagureissues
 from hubs.widgets import githubissues
 from hubs.widgets import bugzilla
 from hubs.widgets import fhosted
+from hubs.widgets import memberships
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -41,6 +42,7 @@ registry = {
     'githubissues': githubissues,
     'bugzilla': bugzilla,
     'fedorahosted': fhosted,
+    'memberships': memberships,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/memberships.py b/hubs/widgets/memberships.py
new file mode 100644
index 0000000..8389657
--- /dev/null
+++ b/hubs/widgets/memberships.py
@@ -0,0 +1,29 @@
+import hubs.models
+from hubs.hinting import hint, prefixed as _
+import hubs.validators as validators
+from hubs.widgets.base import argument
+from hubs.widgets.chrome import panel
+from hubs.widgets import templating
+
+chrome = panel('Hubs')
+template = templating.environment.get_template('templates/memberships.html')
+position = 'both'
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username, **kwargs):
+    user = hubs.models.User.by_username(session, username)
+    memberships = [m.__json__(session) for m in user.memberships
+                   if m.name != user.username and not m.user_hub]
+    return dict(memberships=memberships)
+
+
+@hint(topics=[_('hubs.hub.update')])
+def should_invalidate(message, session, widget):
+    if message['topic'].endswith('hubs.hub.update'):
+        if message['msg']['hub']['name'] == widget.hub.name:
+            return True
+    return False
